Index: plugin/edit.inc.php
===================================================================
--- plugin/edit.inc.php	(.../tags/1.4.7)	(revision 75)
+++ plugin/edit.inc.php	(.../trunk)	(revision 75)
@@ -12,6 +12,7 @@
 function plugin_edit_action()
 {
 	global $vars, $_title_edit, $load_template_func;
+	global $_title_notfound_id, $_title_too_many_id, $_msg_abnormal_id;
 
 	if (PKWK_READONLY) die_message('PKWK_READONLY prohibits editing');
 
@@ -27,10 +28,35 @@
 		return plugin_edit_cancel();
 	}
 
-	$postdata = @join('', get_source($page));
+	$postdata = $vars['original'] = @join('', get_source($page));
+	if (!empty($vars['id'])) {
+		$body = & get_parsed_body();
+		switch ($body->countSectionById($vars['id'])) {
+		case 0:
+			$msg = $_title_notfound_id;
+			break;
+		case 1:
+			$section = & $body->getSectionById($vars['id']);
+			$msg = is_null($section) ? $_title_not_found_id : $_title_edit;
+			break;
+		default:
+			$msg = $_title_too_many_id;
+			break;
+		}
+		if (isset($section)) {
+			$postdata = $section->getText();
+			$form = edit_form($page, rtrim($postdata) . "\n", md5($postdata), false);
+		}
+		else {
+			unset($vars['id']);
+			$form = $_msg_abnormal_id . "\n";
+			$form .= edit_form($page, $postdata);
+		}
+		return array('msg'=>$msg, 'body'=>$form);
+	}
 	if ($postdata == '') $postdata = auto_template($page);
 
-	return array('msg'=>$_title_edit, 'body'=>edit_form($page, $postdata));
+  return array('msg'=>$_title_edit, 'body'=>edit_form($page, $postdata));
 }
 
 // Preview
@@ -94,10 +120,11 @@
 
 	$page    = array_shift($args);
 	if ($page == NULL) $page = '';
-	$_noicon = $_nolabel = FALSE;
+	$_noicon = $_nolabel = $_secedit = FALSE;
 	foreach($args as $arg){
 		switch(strtolower($arg)){
 		case ''       :                   break;
+		case 'secedit': $_secedit = TRUE; $_nolabel = TRUE; break;
 		case 'nolabel': $_nolabel = TRUE; break;
 		case 'noicon' : $_noicon  = TRUE; break;
 		default       : return $usage;
@@ -113,6 +140,7 @@
 	// $s_page fixed
 	$isfreeze = is_freeze($s_page);
 	$ispage   = is_page($s_page);
+	if ($_secedit && $isfreeze) return ''; // Show nothing
 
 	// Paragraph edit enabled or not
 	$short = htmlspecialchars('Edit');
@@ -190,8 +218,32 @@
 	// Collision Detection
 	$oldpagesrc = join('', get_source($page));
 	$oldpagemd5 = md5($oldpagesrc);
+
+	if (!empty($vars['id'])) {
+		$body = & get_parsed_body();
+		if ($section = & $body->getSectionById($vars['id'])) {
+			$oldpagemd5 = md5($section->getText());
+			$section->text = array(rtrim($msg), "\n\n");
+			$postdata = $body->getText();
+		}
+		else {
+			// idб륻󤬤ʤä硢ԽΥƥȤõ
+			$body = & get_parsed_body($vars['original']);
+			if ($section = & $body->getSectionById($vars['id'])) {
+				$oldpagemd5 = md5($section->getText());
+				$section->text = array(rtrim($msg), "\n\n");
+				$postdata = $body->getText();
+			}
+			else {
+				$postdata = $oldpagesrc . "\n\n" . $msg;
+			}
+		}
+		$msg = $postdata;
+	}
+
 	if ($digest != $oldpagemd5) {
-		$vars['digest'] = $oldpagemd5; // Reset
+		$vars['digest'] = $oldpagemd5 = md5($oldpagesrc); // Reset
+		unset($vars['id']);
 
 		$original = isset($vars['original']) ? $vars['original'] : '';
 		list($postdata_input, $auto) = do_update_diff($oldpagesrc, $msg, $original);
Index: ja.lng.php
===================================================================
--- ja.lng.php	(.../tags/1.4.7)	(revision 75)
+++ ja.lng.php	(.../trunk)	(revision 75)
@@ -26,6 +26,9 @@
 $_title_invalidwn  = 'ͭWikiNameǤϤޤ';
 $_title_backuplist = 'Хååװ';
 
+$_title_notfound_id = '$1 ˻ꤵ줿IDĤޤ';
+$_title_too_many_id = '$1 ʣĤλꤵ줿IDĤޤ';
+
 ///////////////////////////////////////
 // Messages
 $_msg_unfreeze       = '';
@@ -40,6 +43,8 @@
 ưǾͤäޤ꤬ǽޤ<br />
 ǧ塢[ڡι]򲡤Ƥ<br />';
 
+$_msg_abnormal_id    = 'ꤵ줿ID˰۾郎뤿ᡢ̾Խڤؤޤ<br />';
+
 $_msg_invalidiwn     = '$1 ͭ $2 ǤϤޤ';
 $_msg_invalidpass    = 'ѥɤְäƤޤ';
 $_msg_notfound       = 'ꤵ줿ڡϸĤޤǤ';
Index: pukiwiki.ini.php
===================================================================
--- pukiwiki.ini.php	(.../tags/1.4.7)	(revision 75)
+++ pukiwiki.ini.php	(.../trunk)	(revision 75)
@@ -413,8 +413,12 @@
 
 /////////////////////////////////////////////////
 // Automatically add fixed heading anchor
-$fixed_heading_anchor = 1;
+$fixed_heading_anchor = 2;
 
+// ФȤԽǽˤ
+// (ͭΥ󥫡Ƥ븫ФԤˤΤͭ)
+$fixed_heading_anchor_edit = 1;
+
 /////////////////////////////////////////////////
 // Remove the first spaces from Preformatted text
 $preformat_ltrim = 1;
Index: lib/convert_html.php
===================================================================
--- lib/convert_html.php	(.../tags/1.4.7)	(revision 75)
+++ lib/convert_html.php	(.../trunk)	(revision 75)
@@ -25,6 +25,22 @@
 	return $body->toString();
 }
 
+function & get_parsed_body($lines = null)
+{
+	global $vars;
+	static $contents_id = 0;
+
+	$body = & new Body(++$contents_id);
+	if (is_null($lines)) $lines = get_source($vars['page']);
+	if (!is_array($lines)) {
+		$lines = explode("\n", $lines);
+		foreach (array_keys($lines) as $i) $lines[$i] .= "\n";
+	}
+
+	$body->parse($lines, true);
+	return $body;
+}
+
 // Block elements
 class Element
 {
@@ -241,7 +257,6 @@
 		$this->level = min(3, strspn($text, '*'));
 		list($text, $this->msg_top, $this->id) = $root->getAnchor($text, $this->level);
 		$this->insert(Factory_Inline($text));
-		$this->level++; // h2,h3,h4
 	}
 
 	function & insert(& $obj)
@@ -258,7 +273,7 @@
 	function toString()
 	{
 		return $this->msg_top .  $this->wrap(parent::toString(),
-			'h' . $this->level, ' id="' . $this->id . '"');
+			'h' . ($this->level + 1), ' id="' . $this->id . '"');
 	}
 }
 
@@ -793,8 +808,131 @@
 	}
 }
 
+//Section
+class Section extends Element
+{
+	var $level;
+	var $title;
+	var $anchorid;
+	var $text;
+
+	function Section($text = '')
+	{
+		parent::Element();
+		$this->level = min(3, strspn($text, '*'));
+		$this->anchorid = make_heading($text, FALSE);
+		$this->title = trim($text);
+		$this->text = array();
+	}
+
+	function canContain($obj)
+	{
+		//ƱؤSectionʤ
+		if (is_a($obj, 'Section') && $obj->level <= $this->level) {
+			return FALSE;
+		}
+		return TRUE;
+	}
+
+	function & addLast(& $obj)
+	{
+		return $this->last = & $this->last->add($obj);
+	}
+
+	function & insert(& $obj)
+	{
+		if (is_a($obj, 'Inline')) $obj = & $obj->toPara();
+		return parent::insert($obj);
+	}
+
+	function & newSection(& $obj)
+	{
+		if ($this->canContain($obj)) {
+			$current = & $this;
+			for ($i=$this->level+1; $i<$obj->level; ++$i) {
+				$current = & $current->newSection(new Section(str_repeat('*', $i)));
+			}
+			$current->addLast($obj);
+			$current->text[] = & $obj;
+
+			// idκ
+			$str = '';
+			if (!$obj->anchorid) {
+				$current = & $obj;
+				while ($current->parent) {
+					$str = $current->title . "\n" . $str;
+					$current = & $current->parent;
+				}
+				$obj->anchorid = chr(ord('a') + hexdec(substr(md5($str), 0, 4)) % 26) . md5($str);
+			}
+			return $obj;
+		}
+		if ($obj->title == '' && $this->level == $obj->level) {
+			$this->text = array_merge($this->text, $obj->text);
+			return $this;
+		}
+		return $this->parent->newSection($obj);
+	}
+
+	function toString()
+	{
+		return $this->wrap(parent::toString(), 'div', ' class="section' . $this->level . '"');
+	}
+
+	// ޤ줿ƥȤ֤
+	function getText()
+	{
+		$text = '';
+		foreach ($this->text as $line) {
+			if (is_a($line, 'Section')) {
+				$text .= $line->getText();
+			}
+			else {
+				$text .= $line;
+			}
+		}
+		return $text;
+	}
+
+	// id饻õ
+	function & getSectionById($id)
+	{
+		if ($this->anchorid == $id) return $this;
+		foreach (array_keys($this->elements) as $i) {
+			if (is_a($this->elements[$i], 'Section')) {
+				$ret = & $this->elements[$i]->getSectionById($id);
+				if (isset($ret)) return $ret;
+			}
+		}
+		return null;
+	}
+
+	// ꤵ줿idθĿ֤
+	function countSectionById($id)
+	{
+		$ret = $this->anchorid == $id ? 1 : 0;
+		foreach ($this->elements as $element) {
+			if (is_a($element, 'Section')) $ret += $element->countSectionById($id);
+		}
+		return $ret;
+	}
+
+	// ΰ֤
+	function getSections()
+	{
+		$ret = array();
+		foreach (array_keys($this->elements) as $i) {
+			if (is_a($this->elements[$i], 'Section')) {
+				$ret[] = & $this->elements[$i];
+				$ret = array_merge($ret, $this->elements[$i]->getSections());
+			}
+		}
+		return $ret;
+	}
+}
+
 // Body
-class Body extends Element
+class Body extends Section
 {
 	var $id;
 	var $count = 0;
@@ -810,29 +948,32 @@
 		'|' => 'Table',
 		',' => 'YTable',
 		'#' => 'Div');
+	var $section;
 
 	function Body($id)
 	{
 		$this->id            = $id;
 		$this->contents      = & new Element();
 		$this->contents_last = & $this->contents;
-		parent::Element();
+		$this->section       = & $this;
+		parent::Section();
 	}
 
-	function parse(& $lines)
+	function parse(& $lines, $collect_text = false)
 	{
 		$this->last = & $this;
 		$matches = array();
 
 		while (! empty($lines)) {
 			$line = array_shift($lines);
+			if ($collect_text) $this->section->text[] = $line;
 
 			// Escape comments
 			if (substr($line, 0, 2) == '//') continue;
 
 			if (preg_match('/^(LEFT|CENTER|RIGHT):(.*)$/', $line, $matches)) {
 				// <div style="text-align:...">
-				$this->last = & $this->last->add(new Align(strtolower($matches[1])));
+				$this->section->addLast(new Align(strtolower($matches[1])));
 				if ($matches[2] == '') continue;
 				$line = $matches[2];
 			}
@@ -841,13 +982,13 @@
 
 			// Empty
 			if ($line == '') {
-				$this->last = & $this;
+				$this->section->last = & $this->section;
 				continue;
 			}
 
 			// Horizontal Rule
 			if (substr($line, 0, 4) == '----') {
-				$this->insert(new HRule($this, $line));
+				$this->section->addLast(new HRule($this, $line));
 				continue;
 			}
 
@@ -857,7 +998,8 @@
 				$len = strlen($matches[1]);
 				$line .= "\r"; // Delimiter
 				while (! empty($lines)) {
-					$next_line = preg_replace("/[\r\n]*$/", '', array_shift($lines));
+					$this->section->text[] = array_shift($lines);
+					$next_line = preg_replace("/[\r\n]*$/", '', end($this->section->text));
 					if (preg_match('/\}{' . $len . '}/', $next_line)) {
 						$line .= $next_line;
 						break;
@@ -872,13 +1014,19 @@
 
 			// Heading
 			if ($head == '*') {
-				$this->insert(new Heading($this, $line));
+				$new = & new Section($line);
+				$new->text[] = array_pop($this->section->text);;
+				$this->section = & $this->section->newSection($new);
+				if (!preg_match('/^\*+\s*$/', $line)) {
+					$this->section->last->insert(new Heading($this, $line));
+				}
+				$this->section->last = & $this->section;
 				continue;
 			}
 
 			// Pre
 			if ($head == ' ' || $head == "\t") {
-				$this->last = & $this->last->add(new Pre($this, $line));
+				$this->section->addLast(new Pre($this, $line));
 				continue;
 			}
 
@@ -889,25 +1037,26 @@
 			// Other Character
 			if (isset($this->classes[$head])) {
 				$classname  = $this->classes[$head];
-				$this->last = & $this->last->add(new $classname($this, $line));
+				$this->section->addLast(new $classname($this, $line));
 				continue;
 			}
 
 			// Other Character
 			if (isset($this->factories[$head])) {
 				$factoryname = 'Factory_' . $this->factories[$head];
-				$this->last  = & $this->last->add($factoryname($this, $line));
+				$this->section->addLast($factoryname($this, $line));
 				continue;
 			}
 
 			// Default
-			$this->last = & $this->last->add(Factory_Inline($line));
+			$this->section->addLast(Factory_Inline($line));
 		}
 	}
 
 	function getAnchor($text, $level)
 	{
 		global $top, $_symbol_anchor;
+		global $fixed_heading_anchor, $fixed_heading_anchor_edit;
 
 		// Heading id (auto-generated)
 		$autoid = 'content_' . $this->id . '_' . $this->count;
@@ -917,32 +1066,32 @@
 		$id = make_heading($text, FALSE); // Cut fixed-anchor from $text
 		if ($id == '') {
 			// Not specified
-			$id     = & $autoid;
+			$id			= & $autoid;
 			$anchor = '';
+			if ($fixed_heading_anchor == 2) {
+				$anchor = ' &aname(' . $this->section->anchorid . ',super,full){' . $_symbol_anchor . '};';
+			}
 		} else {
 			$anchor = ' &aname(' . $id . ',super,full){' . $_symbol_anchor . '};';
 		}
+		if ($fixed_heading_anchor_edit) {
+			$anchor .= " &edit(#{$this->section->anchorid},secedit);";
+		}
 
-		$text = ' ' . $text;
+		$text = ' ' . $this->section->title;
 
 		// Add 'page contents' link to its heading
-		$this->contents_last = & $this->contents_last->add(new Contents_UList($text, $level, $id));
+		$this->contents_last = & $this->contents_last->add(new Contents_UList($text, $level, $autoid));
 
 		// Add heding
 		return array($text . $anchor, $this->count > 1 ? "\n" . $top : '', $autoid);
 	}
 
-	function & insert(& $obj)
-	{
-		if (is_a($obj, 'Inline')) $obj = & $obj->toPara();
-		return parent::insert($obj);
-	}
-
 	function toString()
 	{
 		global $vars;
 
-		$text = parent::toString();
+		$text = Element::toString();
 
 		// #contents
 		$text = preg_replace_callback('/<#_contents_>/',
Index: lib/html.php
===================================================================
--- lib/html.php	(.../tags/1.4.7)	(revision 75)
+++ lib/html.php	(.../trunk)	(revision 75)
@@ -214,6 +214,7 @@
 	$s_digest    = htmlspecialchars($digest);
 	$s_postdata  = htmlspecialchars($refer . $postdata);
 	$s_original  = isset($vars['original']) ? htmlspecialchars($vars['original']) : $s_postdata;
+	$s_id        = isset($vars['id']) ? htmlspecialchars($vars['id']) : '';
 	$b_preview   = isset($vars['preview']); // TRUE when preview
 	$btn_preview = $b_preview ? $_btn_repreview : $_btn_preview;
 
@@ -245,6 +246,7 @@
   <input type="hidden" name="cmd"    value="edit" />
   <input type="hidden" name="page"   value="$s_page" />
   <input type="hidden" name="digest" value="$s_digest" />
+  <input type="hidden" name="id"     value="$s_id" />
   <textarea name="msg" rows="$rows" cols="$cols">$s_postdata</textarea>
   <br />
   <div style="float:left;">
@@ -412,7 +414,7 @@
 	$s_page = substr($page, 0, $pos);
 	$anchor = substr($page, $pos + 1);
 
-	if($strict_editable === TRUE &&  preg_match('/^[a-z][a-f0-9]{7}$/', $anchor)) {
+	if($strict_editable === TRUE &&  preg_match('/^[a-z](?:[a-f0-9]{7}|[a-f0-9]{32})$/', $anchor)) {
 		return array ($s_page, $anchor, TRUE); // Seems fixed-anchor
 	} else {
 		return array ($s_page, $anchor, FALSE);
Index: lib/file.php
===================================================================
--- lib/file.php	(.../tags/1.4.7)	(revision 75)
+++ lib/file.php	(.../trunk)	(revision 75)
@@ -132,7 +132,7 @@
 			$line = preg_replace('/' . $pattern . '/', $replacement, $line);
 		
 		// Adding fixed anchor into headings
-		if ($fixed_heading_anchor &&
+		if ($fixed_heading_anchor == 1 &&
 		    preg_match('/^(\*{1,3}.*?)(?:\[#([A-Za-z][\w-]*)\]\s*)?$/', $line, $matches) &&
 		    (! isset($matches[2]) || $matches[2] == '')) {
 			// Generate unique id
Index: en.lng.php
===================================================================
--- en.lng.php	(.../tags/1.4.7)	(revision 75)
+++ en.lng.php	(.../trunk)	(revision 75)
@@ -25,6 +25,9 @@
 $_title_invalidwn  = 'It is not a valid WikiName';
 $_title_backuplist = 'Backup list';
 
+$_title_notfound_id = 'Can not find the designated ID in $1.';
+$_title_too_many_id = 'Found more than one designated ID in $1.';
+
 ///////////////////////////////////////
 // Messages
 $_msg_unfreeze = 'Unfreeze';
@@ -38,6 +41,8 @@
 $_msg_collided_auto = 'It seems that someone has already updated this page while you were editing it.<br /> The collision has been corrected automatically, but there may still be some problems with the page.<br />
  To confirm the changes to the page, press [Update].<br />';
 
+$_msg_abnormal_id   = 'Since the designated ID is abnormal, the process will change to normal edit mode.<br />';
+
 $_msg_invalidiwn  = ' $1 is not a valid $2.';
 $_msg_invalidpass = 'Invalid password.';
 $_msg_notfound    = 'The page was not found.';
